require 'tar'

if ARGV[0] == "create"

  TapeArchive::File.create( ARGV[1] + ".tar" ) do |file|
    file.new_entry "#{ARGV[1]}/#{ARGV[1]}.txt", :mode=>0644
    file.puts "  But soft, what light through yonder window breaks!"
    file.puts "It is the east, and Juliet is the sun."
    file.puts "  Arise, fair sun, and kill the envious moon, which is"
    file.puts "sick and pale with grief that thou, her maid, art far"
    file.puts "more fair than she.  Be not her maid, for she is"
    file.puts "envious. Her vestal livery is sick and green; cast it"
    file.puts "off!"

    file.new_entry "#{ARGV[1]}/one.txt", :uname=>"user", :gname=>"users"
    file.write "line one\nline two\line three"

    file.new_entry "#{ARGV[1]}/two.txt"
    file.write "another line\nThis is a test of the TapeArchive thing."

    file.new_entry "#{ARGV[1]}/three.txt"
    file.write "and here's another file."
  end

elsif ARGV[0] == "append"

  TapeArchive::File.append( ARGV[1] + ".tar" ) do |file|
    file.new_entry "#{ARGV[1]}/#{ARGV[1]}_#{'%08X'%rand(0xFFFFFFFF)}.txt"
    file.puts "an appended entry!"
  end

elsif ARGV[0] == "open"

  TapeArchive::File.open( ARGV[1] + ".tar" ) do |file|
    file.each_entry do |entry|
      puts "#{entry.name} (#{entry.size} bytes)"
      content = entry.get_input_stream.buffer
      content.each_line do |line|
        puts "  | " + line.chomp
      end
    end
  end

else
  puts "specify 'create', 'append', or 'open', followed by the name of a tar file (without the .tar suffix)"
end
